diff --git a/.appveyor.yml b/.appveyor.yml
index 5b494c1333..17bce8a420 100644
--- a/.appveyor.yml
+++ b/.appveyor.yml
@@ -9,6 +9,7 @@ branches:
 
 environment:
   matrix:
+  - llvm: 4.0.0
   - llvm: 3.9.1
   - llvm: 3.8.1
   - llvm: 3.7.1
@@ -37,7 +38,7 @@ skip_commits:
 
 clone_folder: C:\projects\ponyc
 
-install:
+build_script:
   - ps: |
       $package_commit = git rev-parse --short --verify "HEAD^{commit}"
       $package_version = (Get-Content "VERSION")
@@ -80,9 +81,6 @@ deploy:
         configuration: release
     publish: true
 
-build:
-  none
-
 test_script:
   - ps: |
       cd C:\projects\ponyc
diff --git a/.travis.yml b/.travis.yml
index 6ea250a8d9..3b933e6c55 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -113,6 +113,36 @@ matrix:
         - ICC1=gcc-6
         - ICXX1=g++-6
 
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.0"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=debug
+        - CC1=gcc-6
+        - CXX1=g++-6
+
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=yes
+        - LLVM_VERSION="4.0.0"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=release
+        - CC1=gcc-6
+        - CXX1=g++-6
+
     - os: osx
       env:
         - FAVORITE_CONFIG=no
@@ -170,6 +200,25 @@ matrix:
         - CC1=clang-3.9
         - CXX1=clang++-3.9
 
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.0"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=debug
+        - CC1=clang-3.9
+        - CXX1=clang++-3.9
+
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="3.9.1"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=release
+        - lto=no
+        - CC1=clang-3.9
+        - CXX1=clang++-3.9
+
 rvm:
   - 2.2.3
 
diff --git a/Makefile b/Makefile
index e64a234ac4..54d9949fc8 100644
--- a/Makefile
+++ b/Makefile
@@ -164,10 +164,14 @@ ifeq ($(OSTYPE),osx)
 endif
 
 ifndef LLVM_CONFIG
-	ifneq (,$(shell which /usr/local/opt/llvm@3.9/bin/llvm-config 2> /dev/null))
-    LLVM_CONFIG = /usr/local/opt/llvm@3.9/bin/llvm-config
-    LLVM_LINK = /usr/local/opt/llvm@3.9/bin/llvm-link
-    LLVM_OPT = /usr/local/opt/llvm@3.9/bin/opt
+	ifneq (,$(shell which /usr/local/opt/llvm@4.0/bin/llvm-config 2> /dev/null))
+    LLVM_CONFIG = /usr/local/opt/llvm@4.0/bin/llvm-config
+    LLVM_LINK = /usr/local/opt/llvm@4.0/bin/llvm-link
+    LLVM_OPT = /usr/local/opt/llvm@4.0/bin/opt
+  else ifneq (,$(shell which llvm-config-4.0 2> /dev/null))
+    LLVM_CONFIG = llvm-config-4.0
+    LLVM_LINK = llvm-link-4.0
+    LLVM_OPT = opt-4.0
   else ifneq (,$(shell which llvm-config-3.9 2> /dev/null))
     LLVM_CONFIG = llvm-config-3.9
     LLVM_LINK = llvm-link-3.9
@@ -238,9 +242,10 @@ endif
 ifeq ($(llvm_version),3.7.1)
 else ifeq ($(llvm_version),3.8.1)
 else ifeq ($(llvm_version),3.9.1)
+else ifeq ($(llvm_version),4.0.0)
 else
   $(warning WARNING: Unsupported LLVM version: $(llvm_version))
-  $(warning Please use LLVM 3.7.1, 3.8.1, or 3.9.1)
+  $(warning Please use LLVM 3.7.1, 3.8.1, 3.9.1, or 4.0.0)
 endif
 
 compiler_version := "$(shell $(CC) --version | sed -n 1p)"
diff --git a/src/libponyc/codegen/codegen.h b/src/libponyc/codegen/codegen.h
index bad56402e1..a4bf45c5b3 100644
--- a/src/libponyc/codegen/codegen.h
+++ b/src/libponyc/codegen/codegen.h
@@ -40,6 +40,8 @@ LLVMValueRef LLVMConstNaN(LLVMTypeRef type);
 LLVMValueRef LLVMConstInf(LLVMTypeRef type, bool negative);
 LLVMModuleRef LLVMParseIRFileInContext(LLVMContextRef ctx, const char* file);
 void LLVMSetMetadataStr(LLVMValueRef val, const char* str, LLVMValueRef node);
+void LLVMMDNodeReplaceOperand(LLVMValueRef parent, unsigned i,
+  LLVMValueRef node);
 
 // Intrinsics.
 LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32);
@@ -179,8 +181,10 @@ typedef struct compile_t
   LLVMDIBuilderRef di;
   LLVMMetadataRef di_unit;
   LLVMValueRef tbaa_root;
+#if LLVM_PONY < 400
   LLVMValueRef tbaa_descriptor;
   LLVMValueRef tbaa_descptr;
+#endif  
   LLVMValueRef none_instance;
   LLVMValueRef primitives_init;
   LLVMValueRef primitives_final;
diff --git a/src/libponyc/codegen/genbox.c b/src/libponyc/codegen/genbox.c
index 6dfa6f2278..9a63836cea 100644
--- a/src/libponyc/codegen/genbox.c
+++ b/src/libponyc/codegen/genbox.c
@@ -31,8 +31,12 @@ LLVMValueRef gen_box(compile_t* c, ast_t* type, LLVMValueRef value)
 
   const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return this_ptr;
 }
@@ -60,8 +64,12 @@ LLVMValueRef gen_unbox(compile_t* c, ast_t* type, LLVMValueRef object)
 
   const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, value);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(value, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, value, t->ast_cap);
 }
diff --git a/src/libponyc/codegen/gendebug.cc b/src/libponyc/codegen/gendebug.cc
index cd55089e77..dc13530119 100644
--- a/src/libponyc/codegen/gendebug.cc
+++ b/src/libponyc/codegen/gendebug.cc
@@ -69,16 +69,20 @@ LLVMMetadataRef LLVMDIBuilderCreateCompileUnit(LLVMDIBuilderRef d,
   unsigned lang, const char* file, const char* dir, const char* producer,
   int optimized)
 {
-#if PONY_LLVM >= 309
   DIBuilder* pd = unwrap(d);
-
+  const StringRef flags = "";
+  const unsigned runtimever = 0;
+
+#if PONY_LLVM >= 400
+  DIFile* difile = pd->createFile(file, dir);
+  return wrap(pd->createCompileUnit(lang, difile, producer, 
+    optimized ? true : false, flags, runtimever));
+#elif PONY_LLVM >= 309
   return wrap(pd->createCompileUnit(lang, file, dir, producer, optimized,
-    StringRef(), 0, StringRef())); // use the defaults
+    flags, runtimever, StringRef())); // use the defaults
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createCompileUnit(lang, file, dir, producer, optimized,
-    StringRef(), 0, StringRef(), DIBuilder::FullDebug, 0, true));
+    flags, runtimever, StringRef(), DIBuilder::FullDebug, 0, true));
 #endif
 }
 
@@ -106,26 +110,31 @@ LLVMMetadataRef LLVMDIBuilderCreateMethod(LLVMDIBuilderRef d,
   LLVMMetadataRef file, unsigned line, LLVMMetadataRef type, LLVMValueRef func,
   int optimized)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
   Function* f = unwrap<Function>(func);
 
+#if PONY_LLVM >= 400
   DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
     name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
-    false, true, 0, 0,
-#  if PONY_LLVM >= 309
-    0,
-#  else
-    nullptr,
-#  endif
-    0, optimized);
+    false, true, 0, 0, 0, nullptr, DINode::FlagZero, optimized ? true : false);
 
   f->setSubprogram(di_method);
   return wrap(di_method);
-#else
-  DIBuilder* pd = unwrap(d);
-  Function* f = unwrap<Function>(func);
+#elif PONY_LLVM >= 309
+  DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
+    name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
+    false, true, 0, 0, 0, 0, optimized);
 
+  f->setSubprogram(di_method);
+  return wrap(di_method);
+#elif PONY_LLVM >= 308
+  DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
+    name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
+    false, true, 0, 0, nullptr, 0, optimized);
+
+  f->setSubprogram(di_method);
+  return wrap(di_method);
+#else
   return wrap(pd->createMethod(unwrap<DIScope>(scope), name, linkage,
     unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
     false, true, 0, 0, nullptr, 0, optimized, f));
@@ -136,14 +145,15 @@ LLVMMetadataRef LLVMDIBuilderCreateAutoVariable(LLVMDIBuilderRef d,
   LLVMMetadataRef scope, const char* name, LLVMMetadataRef file,
   unsigned line, LLVMMetadataRef type)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createAutoVariable(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, unwrap<DIType>(type), true, DINode::FlagZero));
+#elif PONY_LLVM >= 308
   return wrap(pd->createAutoVariable(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, unwrap<DIType>(type), true, 0));
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createLocalVariable(DW_TAG_auto_variable,
     unwrap<DIScope>(scope), name, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0));
@@ -154,15 +164,17 @@ LLVMMetadataRef LLVMDIBuilderCreateParameterVariable(LLVMDIBuilderRef d,
   LLVMMetadataRef scope, const char* name, unsigned arg,
   LLVMMetadataRef file, unsigned line, LLVMMetadataRef type)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createParameterVariable(
+    unwrap<DIScope>(scope), name, arg, unwrap<DIFile>(file), line,
+    unwrap<DIType>(type), true, DINode::FlagZero));
+#elif PONY_LLVM >= 308
   return wrap(pd->createParameterVariable(
     unwrap<DIScope>(scope), name, arg, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0));
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createLocalVariable(DW_TAG_arg_variable,
     unwrap<DIScope>(scope), name, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0, arg));
@@ -195,7 +207,13 @@ LLVMMetadataRef LLVMDIBuilderCreateBasicType(LLVMDIBuilderRef d,
   unsigned encoding)
 {
   DIBuilder* pd = unwrap(d);
+
+#if PONY_LLVM >= 400
+  (void)(align_bits);
+  return wrap(pd->createBasicType(name, size_bits, encoding));
+#else
   return wrap(pd->createBasicType(name, size_bits, align_bits, encoding));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreatePointerType(LLVMDIBuilderRef d,
@@ -204,7 +222,7 @@ LLVMMetadataRef LLVMDIBuilderCreatePointerType(LLVMDIBuilderRef d,
   DIBuilder* pd = unwrap(d);
 
   return wrap(pd->createPointerType(unwrap<DIType>(elem_type), size_bits,
-    align_bits));
+    static_cast<uint32_t>(align_bits)));
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateSubroutineType(LLVMDIBuilderRef d,
@@ -231,9 +249,16 @@ LLVMMetadataRef LLVMDIBuilderCreateStructType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createStructType(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, size_bits, 
+    static_cast<uint32_t>(align_bits), DINode::FlagZero, nullptr,
+    elem_types ? DINodeArray(unwrap<MDTuple>(elem_types)) : nullptr));
+#else
   return wrap(pd->createStructType(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, size_bits, align_bits, 0, nullptr,
     elem_types ? DINodeArray(unwrap<MDTuple>(elem_types)) : nullptr));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateReplaceableStruct(LLVMDIBuilderRef d,
@@ -252,9 +277,16 @@ LLVMMetadataRef LLVMDIBuilderCreateMemberType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createMemberType(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, size_bits, static_cast<uint32_t>(align_bits),
+    offset_bits, flags ? DINode::FlagPrivate : DINode::FlagZero, 
+    unwrap<DIType>(type)));
+#else
   return wrap(pd->createMemberType(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, size_bits, align_bits,
     offset_bits, flags, unwrap<DIType>(type)));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateArrayType(LLVMDIBuilderRef d,
@@ -263,7 +295,7 @@ LLVMMetadataRef LLVMDIBuilderCreateArrayType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
-  return wrap(pd->createArrayType(size_bits, align_bits,
+  return wrap(pd->createArrayType(size_bits, static_cast<uint32_t>(align_bits),
     unwrap<DIType>(elem_type), DINodeArray(unwrap<MDTuple>(subscripts))));
 }
 
diff --git a/src/libponyc/codegen/gendesc.c b/src/libponyc/codegen/gendesc.c
index ec38376bee..4452def584 100644
--- a/src/libponyc/codegen/gendesc.c
+++ b/src/libponyc/codegen/gendesc.c
@@ -44,7 +44,6 @@ static LLVMValueRef make_unbox_function(compile_t* c, reach_type_t* t,
   LLVMGetParamTypes(f_type, params);
   LLVMTypeRef ret_type = LLVMGetReturnType(f_type);
 
-  const char* box_name = genname_box(t->name);
   const char* unbox_name = genname_unbox(m->full_name);
   compile_type_t* c_t = (compile_type_t*)t->c_type;
 
@@ -70,9 +69,14 @@ static LLVMValueRef make_unbox_function(compile_t* c, reach_type_t* t,
   LLVMValueRef primitive_ptr = LLVMBuildStructGEP(c->builder, this_ptr, 1, "");
   LLVMValueRef primitive = LLVMBuildLoad(c->builder, primitive_ptr, "");
 
+  const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, primitive);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(primitive, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   primitive = gen_assign_cast(c, c_t->use_type, primitive, t->ast_cap);
 
@@ -414,7 +418,6 @@ void gendesc_init(compile_t* c, reach_type_t* t)
   uint32_t event_notify_index = reach_vtable_index(t, c->str__event_notify);
 
   LLVMValueRef args[DESC_LENGTH];
-
   args[DESC_ID] = LLVMConstInt(c->i32, t->type_id, false);
   args[DESC_SIZE] = LLVMConstInt(c->i32, c_t->abi_size, false);
   args[DESC_FIELD_COUNT] = make_field_count(c, t);
diff --git a/src/libponyc/codegen/genexpr.c b/src/libponyc/codegen/genexpr.c
index a29a1f5472..497e87419c 100644
--- a/src/libponyc/codegen/genexpr.c
+++ b/src/libponyc/codegen/genexpr.c
@@ -31,9 +31,13 @@ LLVMValueRef gen_expr(compile_t* c, ast_t* ast)
       break;
 
     case TK_TUPLEELEMREF:
-      ret = gen_tupleelemptr(c, ast);
+    {
+      ast_t* s_type;
+      uint32_t index;
+      ret = gen_tupleelemptr(c, ast, &s_type, &index);
       break;
-
+    }
+    
     case TK_EMBEDREF:
       ret = gen_fieldembed(c, ast);
       break;
diff --git a/src/libponyc/codegen/genoperator.c b/src/libponyc/codegen/genoperator.c
index bfbb631b26..00c2b57fa0 100644
--- a/src/libponyc/codegen/genoperator.c
+++ b/src/libponyc/codegen/genoperator.c
@@ -345,6 +345,9 @@ static LLVMValueRef assign_local(compile_t* c, LLVMValueRef l_value,
 static LLVMValueRef assign_field(compile_t* c, LLVMValueRef l_value,
   LLVMValueRef r_value, ast_t* p_type, ast_t* l_type, ast_t* r_type)
 {
+  (void)(s_type); // these are for unfinished TBAA work
+  (void)(index);
+
   reach_type_t* t = reach_type(c->reach, l_type);
   pony_assert(t != NULL);
   compile_type_t* c_t = (compile_type_t*)t->c_type;
@@ -359,11 +362,17 @@ static LLVMValueRef assign_field(compile_t* c, LLVMValueRef l_value,
 
   // Store to the field.
   LLVMValueRef store = LLVMBuildStore(c->builder, r_value, l_value);
-
   LLVMValueRef metadata = tbaa_metadata_for_type(c, p_type);
+
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
-  LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
-  LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+  unsigned md_kind = LLVMGetMDKindID(id, sizeof(id) - 1);
+  LLVMSetMetadata(result, md_kind, metadata);
+  LLVMSetMetadata(store, md_kind, metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, result, l_type);
 }
@@ -462,7 +471,9 @@ static LLVMValueRef assign_rvalue(compile_t* c, ast_t* left, ast_t* r_type,
     case TK_TUPLEELEMREF:
     {
       // The result is the previous value of the tuple element.
-      LLVMValueRef l_value = gen_tupleelemptr(c, left);
+      ast_t* s_type;
+      uint32_t index;
+      LLVMValueRef l_value = gen_tupleelemptr(c, left, &s_type, &index);
       ast_t* p_type = ast_type(ast_child(left));
       ast_t* l_type = ast_type(left);
       return assign_field(c, l_value, r_value, p_type, l_type, r_type);
diff --git a/src/libponyc/codegen/genopt.cc b/src/libponyc/codegen/genopt.cc
index dcd7a61b91..bb7bbc968b 100644
--- a/src/libponyc/codegen/genopt.cc
+++ b/src/libponyc/codegen/genopt.cc
@@ -1227,7 +1227,11 @@ bool target_is_x86(char* t)
 {
   Triple triple = Triple(t);
 
+#if PONY_LLVM >= 400
+  const char* arch = Triple::getArchTypePrefix(triple.getArch()).data();
+#else
   const char* arch = Triple::getArchTypePrefix(triple.getArch());
+#endif
 
   return !strcmp("x86", arch);
 }
@@ -1236,7 +1240,11 @@ bool target_is_arm(char* t)
 {
   Triple triple = Triple(t);
 
+#if PONY_LLVM >= 400
+  const char* arch = Triple::getArchTypePrefix(triple.getArch()).data();
+#else
   const char* arch = Triple::getArchTypePrefix(triple.getArch());
+#endif
 
   return !strcmp("arm", arch);
 }
diff --git a/src/libponyc/codegen/genprim.c b/src/libponyc/codegen/genprim.c
index d844d7cacb..2d5d1e096e 100644
--- a/src/libponyc/codegen/genprim.c
+++ b/src/libponyc/codegen/genprim.c
@@ -216,8 +216,12 @@ static void pointer_apply(compile_t* c, void* data, token_id cap)
   ast_setid(tcap, cap);
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   ast_setid(tcap, tmp_cap);
 
@@ -252,9 +256,14 @@ static void pointer_update(compile_t* c, reach_type_t* t,
   LLVMValueRef store = LLVMBuildStore(c->builder, value, loc);
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   result = gen_assign_cast(c, c_t_elem->use_type, result, t_elem->ast_cap);
   LLVMBuildRet(c->builder, result);
@@ -358,8 +367,12 @@ static void pointer_delete(compile_t* c, reach_type_t* t,
   LLVMValueRef result = LLVMBuildLoad(c->builder, elem_ptr, "");
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   LLVMValueRef src = LLVMBuildInBoundsGEP(c->builder, elem_ptr, &n, 1, "");
   src = LLVMBuildBitCast(c->builder, src, c_t->use_type, "");
diff --git a/src/libponyc/codegen/genreference.c b/src/libponyc/codegen/genreference.c
index d24b6c3dc5..6d44dcd817 100644
--- a/src/libponyc/codegen/genreference.c
+++ b/src/libponyc/codegen/genreference.c
@@ -63,9 +63,10 @@ static LLVMValueRef make_fieldptr(compile_t* c, LLVMValueRef l_value,
   pony_assert(ast_id(l_type) == TK_NOMINAL);
   pony_assert(ast_id(right) == TK_ID);
 
-  ast_t* def = (ast_t*)ast_data(l_type);
-  ast_t* field = ast_get(def, ast_name(right), NULL);
-  int index = (int)ast_index(field);
+  ast_t* def;
+  ast_t* field;
+  uint32_t index;
+  get_fieldinfo(l_type, right, &def, &field, &index);
 
   if(ast_id(def) != TK_STRUCT)
     index++;
@@ -104,9 +105,14 @@ LLVMValueRef gen_fieldload(compile_t* c, ast_t* ast)
   compile_type_t* c_t = (compile_type_t*)t->c_type;
 
   field = LLVMBuildLoad(c->builder, field, "");
+
   LLVMValueRef metadata = tbaa_metadata_for_type(c, ast_type(left));
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, field);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(field, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, field, type);
 }
@@ -123,15 +129,16 @@ LLVMValueRef gen_fieldembed(compile_t* c, ast_t* ast)
 }
 
 static LLVMValueRef make_tupleelemptr(compile_t* c, LLVMValueRef l_value,
-  ast_t* l_type, ast_t* right)
+  ast_t* l_type, ast_t* right, uint32_t* index)
 {
   pony_assert(ast_id(l_type) == TK_TUPLETYPE);
-  int index = (int)ast_int(right)->low;
+  *index = (int)ast_int(right)->low;
 
-  return LLVMBuildExtractValue(c->builder, l_value, index, "");
+  return LLVMBuildExtractValue(c->builder, l_value, *index, "");
 }
 
-LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast)
+LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast, ast_t** l_type,
+  uint32_t* index)
 {
   AST_GET_CHILDREN(ast, left, right);
 
diff --git a/src/libponyc/codegen/genreference.h b/src/libponyc/codegen/genreference.h
index cbbca5a03e..6c7f6f16a6 100644
--- a/src/libponyc/codegen/genreference.h
+++ b/src/libponyc/codegen/genreference.h
@@ -16,7 +16,8 @@ LLVMValueRef gen_fieldload(compile_t* c, ast_t* ast);
 
 LLVMValueRef gen_fieldembed(compile_t* c, ast_t* ast);
 
-LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast);
+LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast, ast_t** l_type, 
+  uint32_t* index);
 
 LLVMValueRef gen_tuple(compile_t* c, ast_t* ast);
 
diff --git a/src/libponyc/codegen/gentype.c b/src/libponyc/codegen/gentype.c
index 4592aad51c..2855022f6d 100644
--- a/src/libponyc/codegen/gentype.c
+++ b/src/libponyc/codegen/gentype.c
@@ -19,11 +19,6 @@
 #include <stdlib.h>
 #include <string.h>
 
-static void compile_type_free(void* p)
-{
-  POOL_FREE(compile_type_t, p);
-}
-
 static size_t tbaa_metadata_hash(tbaa_metadata_t* a)
 {
   return ponyint_hash_ptr(a->name);
@@ -116,6 +111,32 @@ LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name)
   return md->metadata;
 }
 
+void tbaa_tag(compile_t* c, LLVMValueRef metadata, LLVMValueRef instr)
+{
+  const char id[] = "tbaa";
+  unsigned md_kind = LLVMGetMDKindID(id, sizeof(id) - 1);
+
+  LLVMValueRef params[3];
+  params[0] = metadata;
+  params[1] = metadata;
+  params[2] = LLVMConstInt(c->i32, 0, false);
+
+  LLVMValueRef tag = LLVMMDNodeInContext(c->context, params, 3);
+  LLVMSetMetadata(instr, md_kind, tag);
+}
+
+void get_fieldinfo(ast_t* l_type, ast_t* right, ast_t** l_def,
+  ast_t** field, uint32_t* index)
+{
+  ast_t* d = (ast_t*)ast_data(l_type);
+  ast_t* f = ast_get(d, ast_name(right), NULL);
+  uint32_t i = (uint32_t)ast_index(f);
+
+  *l_def = d;
+  *field = f;
+  *index = i;
+}
+
 static LLVMValueRef make_tbaa_root(LLVMContextRef ctx)
 {
   const char str[] = "Pony TBAA";
@@ -123,7 +144,10 @@ static LLVMValueRef make_tbaa_root(LLVMContextRef ctx)
   return LLVMMDNodeInContext(ctx, &mdstr, 1);
 }
 
-static LLVMValueRef make_tbaa_descriptor(LLVMContextRef ctx, LLVMValueRef root)
+#if PONY_LLVM < 400
+
+static LLVMValueRef make_tbaa_descriptor(LLVMContextRef ctx, 
+  LLVMValueRef root)
 {
   const char str[] = "Type descriptor";
   LLVMValueRef params[3];
@@ -142,6 +166,13 @@ static LLVMValueRef make_tbaa_descptr(LLVMContextRef ctx, LLVMValueRef root)
   return LLVMMDNodeInContext(ctx, params, 2);
 }
 
+#endif
+
+static void compile_type_free(void* p)
+{
+  POOL_FREE(compile_type_t, p);
+}
+
 static void allocate_compile_types(compile_t* c)
 {
   size_t i = HASHMAP_BEGIN;
@@ -807,8 +838,7 @@ bool gentypes(compile_t* c)
     c->trait_bitmap_size = ((c->reach->trait_type_count + 63) & ~63) >> 6;
 
   c->tbaa_root = make_tbaa_root(c->context);
-  c->tbaa_descriptor = make_tbaa_descriptor(c->context, c->tbaa_root);
-  c->tbaa_descptr = make_tbaa_descptr(c->context, c->tbaa_root);
+
 
   allocate_compile_types(c);
   genprim_builtins(c);
diff --git a/src/libponyc/codegen/gentype.h b/src/libponyc/codegen/gentype.h
index e35d89c26f..5604082972 100644
--- a/src/libponyc/codegen/gentype.h
+++ b/src/libponyc/codegen/gentype.h
@@ -6,6 +6,27 @@
 
 PONY_EXTERN_C_BEGIN
 
+typedef struct tbaa_metadata_t
+{
+  const char* name;
+  LLVMValueRef metadata;
+} tbaa_metadata_t;
+
+DECLARE_HASHMAP(tbaa_metadatas, tbaa_metadatas_t, tbaa_metadata_t);
+
+tbaa_metadatas_t* tbaa_metadatas_new();
+
+void tbaa_metadatas_free(tbaa_metadatas_t* tbaa_metadatas);
+
+LLVMValueRef tbaa_metadata_for_type(compile_t* c, ast_t* type);
+
+LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name);
+
+void tbaa_tag(compile_t* c, LLVMValueRef metadata, LLVMValueRef instr);
+
+void get_fieldinfo(ast_t* l_type, ast_t* right, ast_t** l_def,
+  ast_t** field, uint32_t* index);
+
 typedef struct compile_type_t
 {
   compile_opaque_free_fn free_fn;
@@ -37,22 +58,6 @@ typedef struct compile_type_t
   LLVMMetadataRef di_type_embed;
 } compile_type_t;
 
-typedef struct tbaa_metadata_t
-{
-  const char* name;
-  LLVMValueRef metadata;
-} tbaa_metadata_t;
-
-DECLARE_HASHMAP(tbaa_metadatas, tbaa_metadatas_t, tbaa_metadata_t);
-
-tbaa_metadatas_t* tbaa_metadatas_new();
-
-void tbaa_metadatas_free(tbaa_metadatas_t* tbaa_metadatas);
-
-LLVMValueRef tbaa_metadata_for_type(compile_t* c, ast_t* type);
-
-LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name);
-
 bool gentypes(compile_t* c);
 
 PONY_EXTERN_C_END
diff --git a/src/libponyc/codegen/host.cc b/src/libponyc/codegen/host.cc
index 1e22f60db2..24e8cf5fb0 100644
--- a/src/libponyc/codegen/host.cc
+++ b/src/libponyc/codegen/host.cc
@@ -206,6 +206,18 @@ void LLVMSetMetadataStr(LLVMValueRef inst, const char* str, LLVMValueRef node)
   unwrap<Instruction>(inst)->setMetadata(str, n);
 }
 
+void LLVMMDNodeReplaceOperand(LLVMValueRef parent, unsigned i, 
+  LLVMValueRef node)
+{
+  pony_assert(parent != NULL);
+  pony_assert(node != NULL);
+  pony_assert((int)i >= 0);
+
+  MDNode *pn = extractMDNode(unwrap<MetadataAsValue>(parent));
+  MDNode *cn = extractMDNode(unwrap<MetadataAsValue>(node));
+  pn->replaceOperandWith(i, cn);
+}
+
 LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32)
 {
   Module* m = unwrap(module);
diff --git a/src/libponyc/platform/vcvars.c b/src/libponyc/platform/vcvars.c
index 237d2c3cb4..e7fa3a0915 100644
--- a/src/libponyc/platform/vcvars.c
+++ b/src/libponyc/platform/vcvars.c
@@ -224,7 +224,11 @@ static bool find_kernel32(vcvars_t* vcvars, errors_t* errors)
 
   vcvars->ucrt[0] = '\0';
   strcpy(vcvars->default_libs,
-    "kernel32.lib msvcrt.lib Ws2_32.lib advapi32.lib vcruntime.lib "
+    "kernel32.lib "
+#if !defined(DEBUG)
+    "msvcrt.lib "
+#endif
+    "Ws2_32.lib advapi32.lib vcruntime.lib "
     "legacy_stdio_definitions.lib dbghelp.lib");
 
   strcpy(vcvars->kernel32, sdk.path);
diff --git a/wscript b/wscript
index 9f8007e226..7fc6985354 100644
--- a/wscript
+++ b/wscript
@@ -34,21 +34,21 @@ out = 'build'
 
 # various configuration parameters
 CONFIGS = [
-    'debug',
-    'release'
+    'release',
+    'debug'
 ]
 
 MSVC_VERSIONS = [ '15', '14' ]
 
 # keep these in sync with the list in .appveyor.yml
 LLVM_VERSIONS = [
+    '4.0.0',
     '3.9.1',
-    '3.9.0',
     '3.8.1',
     '3.7.1'
 ]
 
-WINDOWS_LIBS_TAG = "v1.2.0"
+WINDOWS_LIBS_TAG = "v1.4.0"
 LIBRESSL_VERSION = "2.5.0"
 PCRE2_VERSION = "10.21"
 
@@ -76,12 +76,6 @@ def configure(ctx):
 
     if os_is('win32'):
         import os
-        ctx.env.PONYC_EXTRA_LIBS = [
-            'kernel32', 'user32', 'gdi32', 'winspool', 'comdlg32',
-            'advapi32', 'shell32', 'ole32', 'oleaut32', 'uuid',
-            'odbc32', 'odbccp32', 'vcruntime', 'ucrt', 'Ws2_32',
-            'dbghelp', 'Shlwapi'
-        ]
 
         base_env = ctx.env
         base_env.MSVC_VERSIONS = [ 'msvc ' + v + '.0' for v in MSVC_VERSIONS ]
@@ -99,41 +93,57 @@ def configure(ctx):
 
         for llvm_version in LLVM_VERSIONS:
             bld_env = base_env.derive()
-            bld_env.PONYLIBS_NAME = 'PonyWindowsLibs' + \
-                '-LLVM-' + llvm_version + \
-                '-LibreSSL-' + LIBRESSL_VERSION + \
-                '-PCRE2-' + PCRE2_VERSION + '-' + \
-                WINDOWS_LIBS_TAG
-            bld_env.PONYLIBS_DIR = bld_env.PONYLIBS_NAME
+            bld_env.PONYLIBS_DIR = 'ThirdParty'
             bld_env.LIBRESSL_DIR = os.path.join(bld_env.PONYLIBS_DIR, \
                 'lib', 'libressl-' + LIBRESSL_VERSION)
             bld_env.PCRE2_DIR = os.path.join(bld_env.PONYLIBS_DIR, \
                 'lib', 'pcre2-' + PCRE2_VERSION)
-            bld_env.LLVM_DIR = os.path.join(bld_env.PONYLIBS_DIR, \
-                'lib', 'LLVM-' + llvm_version)
             bld_env.append_value('DEFINES', [
                 'LLVM_VERSION="' + llvm_version + '"'
             ])
 
+            libs_name = 'PonyWinLibs' + \
+                '-LLVM-' + llvm_version + \
+                '-LibreSSL-' + LIBRESSL_VERSION + \
+                '-PCRE2-' + PCRE2_VERSION + '-' + \
+                WINDOWS_LIBS_TAG
+
+            # Debug configuration
             bldName = 'debug-llvm-' + llvm_version
             ctx.setenv(bldName, env = bld_env)
+            ctx.env.PONYLIBS_NAME = libs_name + '-Debug'
+            ctx.env.LLVM_DIR = os.path.join(ctx.env.PONYLIBS_DIR, \
+                'lib', 'LLVM-' + llvm_version + '-Debug')
+
             ctx.env.append_value('DEFINES', [
                 'DEBUG',
-                'PONY_BUILD_CONFIG="debug"'
+                'PONY_BUILD_CONFIG="debug"',
+                '_SCL_SECURE_NO_WARNINGS'
             ])
             msvcDebugFlags = [
                 '/EHsc', '/MP', '/GS', '/W3', '/Zc:wchar_t', '/Zi',
                 '/Gm-', '/Od', '/Zc:inline', '/fp:precise', '/WX',
-                '/Zc:forScope', '/Gd', '/MD', '/FS', '/DEBUG'
+                '/Zc:forScope', '/Gd', '/MDd', '/FS', '/DEBUG'
             ]
             ctx.env.append_value('CFLAGS', msvcDebugFlags)
             ctx.env.append_value('CXXFLAGS', msvcDebugFlags)
             ctx.env.append_value('LINKFLAGS', [
-                '/NXCOMPAT', '/SUBSYSTEM:CONSOLE', '/DEBUG'
+                '/NXCOMPAT', '/SUBSYSTEM:CONSOLE', '/DEBUG', '/ignore:4099'
             ])
+            ctx.env.PONYC_EXTRA_LIBS = [
+                'kernel32', 'user32', 'gdi32', 'winspool', 'comdlg32',
+                'advapi32', 'shell32', 'ole32', 'oleaut32', 'uuid',
+                'odbc32', 'odbccp32', 'vcruntimed', 'ucrtd', 'Ws2_32',
+                'dbghelp', 'Shlwapi'
+            ]
 
+            # Release configuration
             bldName = 'release-llvm-' + llvm_version
             ctx.setenv(bldName, env = bld_env)
+            ctx.env.PONYLIBS_NAME = libs_name + '-Release'
+            ctx.env.LLVM_DIR = os.path.join(ctx.env.PONYLIBS_DIR, \
+                'lib', 'LLVM-' + llvm_version + '-Release')
+
             ctx.env.append_value('DEFINES', [
                 'NDEBUG',
                 'PONY_BUILD_CONFIG="release"'
@@ -148,6 +158,12 @@ def configure(ctx):
             ctx.env.append_value('LINKFLAGS', [
                 '/NXCOMPAT', '/SUBSYSTEM:CONSOLE'
             ])
+            ctx.env.PONYC_EXTRA_LIBS = [
+                'kernel32', 'user32', 'gdi32', 'winspool', 'comdlg32',
+                'advapi32', 'shell32', 'ole32', 'oleaut32', 'uuid',
+                'odbc32', 'odbccp32', 'vcruntime', 'ucrt', 'Ws2_32',
+                'dbghelp', 'Shlwapi'
+            ]            
 
 
 # specifies build targets
@@ -184,7 +200,7 @@ def build(ctx):
                 and os.path.exists(pcre2Dir) \
                 and os.path.exists(llvmDir)):
                 libsZip = libsName + '.zip'
-                libsFname = os.path.join(buildDir, libsZip)
+                libsFname = os.path.join(buildDir, '..', libsZip)
                 if not os.path.isfile(libsFname):
                     libsUrl = 'https://github.com/kulibali/ponyc-windows-libs/releases/download/' \
                         + WINDOWS_LIBS_TAG + '/' + libsZip
@@ -210,7 +226,10 @@ def build(ctx):
                     zf.extractall(libsDir)
 
                 import shutil
-                shutil.copy(os.path.join(pcre2Dir, 'pcre2-8.lib'), buildDir)
+                if (ctx.options.config == 'debug'):
+                    shutil.copy(os.path.join(pcre2Dir, 'pcre2-8d.lib'), buildDir)
+                else:
+                    shutil.copy(os.path.join(pcre2Dir, 'pcre2-8.lib'), buildDir)
                 shutil.copy(os.path.join(libresslDir, 'lib', 'crypto.lib'), buildDir)
                 shutil.copy(os.path.join(libresslDir, 'lib', 'ssl.lib'), buildDir)
                 shutil.copy(os.path.join(libresslDir, 'lib', 'tls.lib'), buildDir)
@@ -318,6 +337,11 @@ def build(ctx):
         lib       = ctx.env.PONYC_EXTRA_LIBS
     )
 
+
+# this command builds and runs the test suites
+def test(ctx):
+    import os
+
     # stdlib tests
     stdlibTarget = 'stdlib'
     if os_is('win32'):
@@ -337,49 +361,47 @@ def build(ctx):
         target   = 'pony.g.new',
     )
 
-
-# this command runs the test suites
-def test(ctx):
-    import os
-
-    buildDir = ctx.bldnode.abspath()
-    sourceDir = ctx.srcnode.abspath()
-
-    total = 0
-    passed = 0
-
-    total = total + 1
-    testc = os.path.join(buildDir, 'testc')
-    returncode = subprocess.call([ testc ])
-    if returncode == 0:
-        passed = passed + 1
-
-    total = total + 1
-    testrt = os.path.join(buildDir, 'testrt')
-    print(testrt)
-    returncode = subprocess.call([ testrt ])
-    if returncode == 0:
-        passed = passed + 1
-
-    total = total + 1
-    stdlib = os.path.join(buildDir, 'stdlib')
-    print(stdlib)
-    returncode = subprocess.call([ stdlib, '--sequential' ])
-    if returncode == 0:
-        passed = passed + 1
-
-    print('')
-    print('{0} test suites; {1} passed; {2} failed'.format(total, passed, total - passed))
-    if passed < total:
-        sys.exit(1)
-    
-    ponyg = os.path.join(sourceDir, 'pony.g')
-    ponygNew = os.path.join(buildDir, 'pony.g.new')
-    with open(ponyg, 'r') as pg:
-        with open(ponygNew, 'r') as pgn:
-            if pg.read() != pgn.read():
-                print('Grammar files differ')
-                sys.exit(1)
+    def run_tests(ctx):
+        buildDir = ctx.bldnode.abspath()
+        sourceDir = ctx.srcnode.abspath()
+
+        total = 0
+        passed = 0
+
+        total = total + 1
+        testc = os.path.join(buildDir, 'testc')
+        returncode = subprocess.call([ testc ])
+        if returncode == 0:
+            passed = passed + 1
+
+        total = total + 1
+        testrt = os.path.join(buildDir, 'testrt')
+        print(testrt)
+        returncode = subprocess.call([ testrt ])
+        if returncode == 0:
+            passed = passed + 1
+
+        total = total + 1
+        stdlib = os.path.join(buildDir, 'stdlib')
+        print(stdlib)
+        returncode = subprocess.call([ stdlib, '--sequential' ])
+        if returncode == 0:
+            passed = passed + 1
+
+        print('')
+        print('{0} test suites; {1} passed; {2} failed'.format(total, passed, total - passed))
+        if passed < total:
+            sys.exit(1)
+
+        ponyg = os.path.join(sourceDir, 'pony.g')
+        ponygNew = os.path.join(buildDir, 'pony.g.new')
+        with open(ponyg, 'r') as pg:
+            with open(ponygNew, 'r') as pgn:
+                if pg.read() != pgn.read():
+                    print('Grammar files differ')
+                    sys.exit(1)
+
+    ctx.add_post_fun(run_tests)
 
 
 # subclass the build context for the test command,
